SystemOrganization addCategory: #GraphOfMetacello!

Object subclass: #GraphOfMetacello
	instanceVariableNames: 'graph metacelloVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GraphOfMetacello'!

!GraphOfMetacello class methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/7/2014 17:39'!
howYouDoIt
"
gm := GraphOfMetacello new.
gm metacelloVersion: ConfigurationOfVersionnerTestBitmapCharacterSet project lastVersion.

gm focusOnThoseRelatedToSpecNamed: 'UndoRedo'.

Clipboard clipboardText: gm graph dotFileContents.
"! !

!GraphOfMetacello methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/20/2014 23:09'!
connectEdges

	self graph vertices do: [:each|
		each masterObject requires
			do: [:reqPackName | 
				each connectTo: (self getVertexOfSpecName: reqPackName)]]! !

!GraphOfMetacello methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/21/2014 16:46'!
focusOnSpecNamed: aString 

	self graph cropNeighborsAndBackNeighborsOfVertex: (self getVertexOfSpecName: aString)! !

!GraphOfMetacello methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/26/2014 20:31'!
focusOnThoseRelatedToSpecNamed: aString 

	self graph cropRelatedToVertex: (self getVertexOfSpecName: aString)! !

!GraphOfMetacello methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/20/2014 22:38'!
getVertexOfSpecName: aString 
	^self graph vertices detect: [ :each| each masterObject specItem name = aString ]! !

!GraphOfMetacello methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/17/2014 13:16'!
graph
	^graph setDefault: #graphDefault for: self withSetter: #graph: afterSetOperation: #connectEdges! !

!GraphOfMetacello methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/17/2014 12:57'!
graph: aGraph 
	graph := aGraph! !

!GraphOfMetacello methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/20/2014 22:33'!
graphDefault
	|g blk|
	g := Graph new.
	blk := [:each | 
			g createVertexAndAddIt
				masterObject: 
					(MetacelloPackageGraphVertex new
						specItem: each)].
	self metacelloVersion spec 
		projectDo: blk
		packageDo: blk 
		groupDo: blk.
	^g! !

!GraphOfMetacello methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/20/2014 22:37'!
metacelloVersion
	^metacelloVersion! !

!GraphOfMetacello methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/17/2014 13:00'!
metacelloVersion: anObject

	metacelloVersion := anObject! !

Object subclass: #MetacelloPackageGraphVertex
	instanceVariableNames: 'specItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GraphOfMetacello'!

!MetacelloPackageGraphVertex methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/7/2014 17:34'!
nodeNameForDotFile
	^'"', specItem name, '"'! !

!MetacelloPackageGraphVertex methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/7/2014 17:34'!
printVertexDetailOn: aLimitedWriteStream 
	aLimitedWriteStream nextPutAll: specItem name.! !

!MetacelloPackageGraphVertex methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/17/2014 17:38'!
requires
	^specItem requires ! !

!MetacelloPackageGraphVertex methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/17/2014 17:38'!
specItem
	^ specItem! !

!MetacelloPackageGraphVertex methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/17/2014 17:38'!
specItem: aMetacelloPackageSpec 
	specItem := aMetacelloPackageSpec ! !
